> For the complete documentation index, see [llms.txt](https://docs.cotter.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cotter.app/sdk-reference/flutter/getting-oauth-tokens.md).

# Getting OAuth Tokens

When a user successfully logged-in, Cotter will generate an `access_token` , an `id_token` , and a `refresh_token` [that you can use in your backend API](https://blog.cotter.app/passwordless-login-with-email-and-json-web-token-jwt-authentication-with-nextjs/).&#x20;

The SDK automatically stores these tokens in the device's secure storage.

#### Getting The Tokens

```dart
Cotter cotter = new Cotter(apiKeyID: API_KEY_ID);
try {
  var accessToken = await cotter.getAccessToken();
  var idToken = await cotter.getIDToken();
  var refreshToken = await cotter.getRefreshToken();
} catch (e) {
  print(e);
}
```

This function will automatically refresh the `access_token` and `id_token` if it's expired.

## OAuth Token Specification

{% content-ref url="/pages/-M4HUyse-9aPxMqUoSRy" %}
[Cotter's OAuth 2.0 Tokens Specification](/getting-access-token/handling-authentication-with-cotter.md)
{% endcontent-ref %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cotter.app/sdk-reference/flutter/getting-oauth-tokens.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
